<?php
/* New page definer */
if(!defined('IN_SCRIPT')){
	exit;
}
// target files we need, so make sure they are present
$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['data_root']."/extra.php");
for($x=0;$x<count($aFiles);$x++){
	(!IsThere($aFiles[$x]) ? include($_PATHS['end']) : include($aFiles[$x]));
}
if(isset($_POST['sFile'])){
	// let's see if we have a valid php file
	$sFileL = str_replace("%","",str_replace("/","",$_POST['sFile']));
	$aIsPHP = explode(".",$sFileL);
	if($aIsPHP[count($aIsPHP)-1]!="php"){
		$_CONTEXT['errors'][] = "Expecting file to be a php file";
		include($_PATHS['end']);
	}
	// make full path to file
	$sFileR = $_PATHS['root']."/".$sFileL;
	(!IsThere($sFileR) ? include($_PATHS['end']) : include_once($sFileR));
	if(!isset($_IDENTIFY['label'])){
		$_CONTEXT['errors'][] = "Corrupt file, expecting identification label in ".$sFileL;
		include($_PATHS['end']);
	}
	$sLabel = @strip_tags($_IDENTIFY['label']);
	if(!$sLabel || strlen($sLabel)>25){
		$_CONTEXT['errors'][] = "Invalid label name";
		include($_PATHS['end']);
	}
	// while we are at it, let's template the thing and abort if anything goes wrong
	$sTemplate = "<?php\n";
	$sTemplate .= "/* extra pages */\n";
	$sTemplate .= "\$aExtra = array();\n";
	if(0!=($iExtra = @count($aExtra))){
		for($x=0;$x<$iExtra;$x++){
			// well all fair so far, but does the entry already exists?
			if($aExtra[$x][0]==$sLabel || $aExtra[$x][1]==$sFileL){
				// already exists
				$_CONTEXT['errors'][] = "Entry already exists";
				include($_PATHS['end']);
			}
			$sTemplate .= "\$aExtra[".$x."] = array(\"".$aExtra[$x][0]."\",\"".$aExtra[$x][1]."\");\n";
		}
	}
	// now add the new item
	$sTemplate .= "\$aExtra[".$iExtra."] = array(\"".$sLabel."\",\"".$sFileL."\");\n";
	$sTemplate .= "?>";
	if(!WriteF($aFiles[1],$sTemplate,"w")){
		// update failed
		include($_CONTEXT['end']);
	}
	else{
		$sCode .= "<font class=\"spacing\">Update succeeded, click <a href=\"".$sFileL."\">here</a> to continue</font>\n";
	}
}
else{
	/* add new pages form */
	$sCode .= "<form method=\"post\">\n";
	$sCode .= "	<div class=\"configtablewrap\">\n";
	$sCode .= "		<div class=\"configtable\">\n";
	$sCode .= "			<div class=\"configtablerow\">\n";
	$sCode .= "				<div class=\"configtabledesc\">Adds new applications to the hacksuite environment.</div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			<div class=\"clear\"></div>\n";
	$sCode .= "			<div class=\"configtablerow\">\n";
	$sCode .= "				<div class=\"configtableleft\">file name:</div><div class=\"configtableright\"><input type=\"text\" name=\"sFile\" value=\"\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			<div class=\"clear\"></div>\n";
	$sCode .= "			<div class=\"configtablerow\">\n";
	$sCode .= "				<div class=\"configtablesubmit\"><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\"><input type=\"submit\" name=\"submit\" value=\"Add Path\"></div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "		</div>\n";
	$sCode .= "	</div>\n";
	$sCode .= "</form>\n";
}
?>