<?php
/* proxy manager */
if(!defined('IN_SCRIPT')){
	exit;
}
$sDest = $_PATHS['includes_root']."/proxies.php";
(!IsThere($sDest) ? include($_PATHS['end']) : include($sDest));
$sDest = $_PATHS['data_root']."/proxyoptions.php";
(!IsThere($sDest) ? include($_PATHS['end']) : include($sDest));
if(!isset($_PFORM) || !$_PFORM){
	$_CONTEXT['errors'][] = "No data for rendering forms in <b>".$sDest."</b>";
	include($PATHS['end']);
}
$iForms = count($_PFORM);
$iModes = count($_PMODES);
$iFormMargin = 10;
if(!isset($_POST['sProxy'])){
	// create a dynamic form in order to show the proper options
	$sOut = "";
	// dynamic jQuery for switching forms
	$sJS = "\n\$(function(){\n";
	// dynamic css for positioning elements
	$sCSS = "<style type=\"text/css\">\n";
	$aForms = array();
	for($y=0;$y<$iModes;$y++){
		// only show the first form by default
		$sJS .= "	\$('.form".$y."').".($y==0 ? "show()" : "hide('slow')").";\n";
		$aForms[] = ".form".$y;
	}
	$sCSS .= "<!--\n".implode(",",$aForms)."{ margin:".$iFormMargin."px; }\n";
	$sCSS .= ".bigtxt { margin:5px;font-size:15px;font-weight:bold; }\n";
	// default field actions
	$sJS .= "	// make stuff appear or dissapear depending on selected proxy mode\n";
	$sJS .= "	\$(\".proxym\").change(function() {\n";
	// if-else statements
	for($x=0;$x<$iModes;$x++){
		$sJS .= "		".($x!=0 ? "else " : "")."if(this.value=='".$x."'){\n";
		for($y=0;$y<$iModes;$y++){
			$sJS .= "			\$('.form".$y."').".($x==$y ? "show()" : "hide('slow')").";\n";
		}
		$sJS .= "		}\n";
	}
	$sJS .= "	});\n";
	$sJS .= "});";
	// encaps in script tag and add to the code
	$sCode .= "\n<script type=\"text/javascript\">".$sJS."</script>\n";
	$_CLASSES = array();
	for($x=0;$x<count($_SUBMIT);$x++){
		if(!isset($_PFORM[$x])){
			continue;
		}
		$sOut .= "<form method=\"post\">\n";
		$sOut .= "	<div class=\"form".$x."\">\n";
		$sOut .= "	<div class=\"bigtxt\">".$_SUBMIT[$x]."</div>\n";
		for($y=0;$y<count($_PFORM[$x]);$y++){
			// generate fields
			$_CLASSES[] = ".".$_PFORM[$x][$y]['class'];
			$sOut .= "		<div class=\"".$_PFORM[$x][$y]['class']."\">\n";
			$sOut .= ($_PFORM[$x][$y]['text']=="" ? "" : "			<div class=\"fieldleft\">".$_PFORM[$x][$y]['text']."</div>\n")."			<div class=\"fieldright\">".$_PFORM[$x][$y]['input']."</div>\n";
			$sOut .= "		</div>\n";
		}
		$sOut .= "	</div>\n";
		$sOut .= "</form>\n";
	}
	$_CLASSES = array_unique($_CLASSES);
	$sCSS .= implode(",",$_CLASSES)." { width:550px;display:block;margin:0 auto; }\n";
	$sCSS .= "div.fieldleft { width:125px;float:left; }\n";
	$sCSS .= "div.fieldright { margin-left:5px;width:400px;float:left; }\n";
	$sCSS .= "-->\n";
	$sCSS .= "</style>\n";
	// add the css elements to the code
	$sCode .= $sCSS;
	// we're done with creating the forms
	$sCode .= $sOut;
	// make some room..
	$_PFORM = "";
	$sOut = "";
	$sJS = "";
}
else{
	// we will need writing in more than one case
	if(!function_exists('WriteF')){
		include($_PATHS['functions_root']."/fwrite.php");
	}
	$sDest = $_PATHS['data_root']."/proxies.txt";
	switch($_POST['sProxy']){
		// remove proxy
		case"Remove":
		$iProxy = intval($_POST['iProxy']);
		$aFile = file($sDest);
		$sData = "";
		for($x=0;$x<count($aFile);$x++){
			$sData .= ($iProxy==$x ? "" : $aFile[$x]);
		}
		$sCode .= (WriteF($sDest,$sData,"w")==true ? "Successfully removed proxy" : "Proxy remove failed");
		break;
		// proxy scrape
		case"Scrape":
		$sScrapePattern = "/(http:\/\/)?[1-2]?[0-9]{1,3}.[1-2]?[0-9]{1,3}.[1-2]?[0-9]{1,3}.[1-2]?[0-9]{1,3}[: ][1-9]?[0-9]{1,5}/is";
		if(!function_exists("GetFileData")){
			include($_PATHS['functions_root']."/get_file_data.php");
		}
		if(false==($sFile = GetFileData($_POST['sUrl']))){
			$sCode .= "Failed to get file content";
		}
		else{
			preg_match_all($sScrapePattern,$sFile,$aMatches);
			$sProxyList = "";
			for($x=0;$x<count($aMatches[0]);$x++){
				$sProxyList .= $aMatches[0][$x]."\n";
			}
		}
		// fall through and make use of the Import option to store the scrape
		$_POST['sProxy'] = "Import";
		// import proxylist
		case"Import":
		$sProxyList = (isset($sProxyList) ? $sProxyList : trim($_POST['sProxyList']));
		if(!@strlen($sProxyList)){
			$sCode .= "<b>No list to import</b>";
		}
		else{
			$aProxyList = explode("\n",$sProxyList);
			$sBuffer = "";
			for($x=0;$x<count($aProxyList);$x++){
				// filter invalid values
				if($aProxyList[$x]=="" || (false===($iPosPort = @strrpos($aProxyList[$x],":")))){
					continue;
				}
				$sBuffer .= substr($aProxyList[$x],0,$iPosPort)."|".trim(substr($aProxyList[$x],($iPosPort+1)))."|\n";
			}
			$sCode .= (WriteF($sDest,$sBuffer,"a")==true ? "Successfully added list" : "List insert failed");
		}
		break;
		// proxy test
		case"Test":
		$fp = @fsockopen($_POST['sProxyAddress'],$_POST['iProxyPort'],$errno,$errstr,1);
		if(!$fp){
			$sCode .= "<b>Proxy is offline</b>";
			break;
		}
		else{
			if(isset($_POST['iLogProxy']) && $_POST['iLogProxy']==1){
				// fall through and make use of the Insert option to store the tested item
				$_POST['sProxy'] = "Insert";
				if(false===($iPosPort = @strrpos($_POST['sProxyAddress'],":"))){
					$_POST['iProxyPort'] = trim(substr($_POST['sProxyAddress'],($iPosPort+1)));
				}
			}
			else{
				$sCode .= "<b>Proxy is online</b>";
				break;
			}
		}
		// add proxy
		case"Insert":
		$iProxyPort = @intval($_POST['iProxyPort']);
		$aUrl = @parse_url($_POST['sProxyAddress']);
		if(!isset($_POST['sCredentials']) || ($_POST['sCredentials']!="" && strpos($_POST['sCredentials'],":")===false)){
			$sCode .= "<b>Wrong credentials.. you should separate the user and pass by the : character</b>";
		}
		elseif(!is_int($iProxyPort) || ($iProxyPort<0 || $iProxyPort>65535)){
			$sCode .= "<b>Invalid port number</b>";
		}
		elseif(!isset($aUrl['host'])){
			$sCode .= "<b>Invalid host address</b>";
		}
		else{
			$aUrl['scheme'] = (strlen($aUrl['scheme'])>1 ? $aUrl['scheme']."://" : "");
			$_POST['sCredentials'] = ($_POST['sCredentials']=="" ? "" : trim($_POST['sCredentials']));
			$sCode .= (WriteF($sDest,$aUrl['scheme'].$aUrl['host']."|".$iProxyPort."|".$_POST['sCredentials']."\n","a")==true ? "Successfully added proxy" : "Proxy insert failed");
		}
		break;
		default:
		$_CONTEXT['errors'][] = "Invalid proxy manager option";
		include($PATHS['end']);
	}
}
?>