<?php
/* Handle errors that may have occured */
if(!defined('IN_SCRIPT')){
	exit;
}
// is logging enabled?
if($_CONTEXT['log']==true && !defined('LOG_SKIP') ){
	// now if we call IsThere we might just bump into an infinite loop, so let's include the log handler
	@include_once($_PATHS['includes_root']."/log_error.php");
}
if($_CONTEXT['silent']==true){
	// keep output empty
	exit;
}
include($_PATHS['style_root']."/head.php");
// what if the headers already are sent?
$iErrors = count($_CONTEXT['errors']);
/* output error */
if($iErrors!=0){
	$sCode = "<div class=\"spacing\">";
	for($x=0;$x<$iErrors;$x++){
		$sCode .= "<b>error message:</b> ".(@strlen($_CONTEXT['errors'][$x])>0 ? strip_tags($_CONTEXT['errors'][$x],"<p><a><b><i><u>") : "no error defined")."<br>\n";
		if($x==($iErrors-1)){
			// ok this is the last item, if there was a fatal set then show it now
			if($_CONTEXT['fatal']){
				$sCode .= "<b>type of error:</b> fatal<br>\n";
				break;
			}
		}
		$sCode .= "<b>type of error:</b> not critical<br>\n";
	}
	$sCode .= "</div>";
	include($_PATHS['style_root']."/body.php");
	include($_PATHS['style_root']."/footer.php");
	/* make sure we don't go ahead with more code parsing */
	exit;
}
// no errors occured, still it's strange and it will be logged, always make sure you set the error in the array $_CONTEXT['errors']
$_CONTEXT['errors'][] = "No error defined for an error.. continue parsing..";
?>