<?php
class Destination{
	var $sDestination;
	var $iType;
	/* getter and setter methods */
	function GetDest(){
		return($this->sDestination);
	}
	function SetDest($sDestination){
		$this->sDestination = $sDestination;
	}
	function GetType(){
		return($this->iType);
	}
	function SetType($iType){
		$this->iType = $iType;
	}
	/* other methods */
	function Destination(){
	}
	// get via socket
	function SocketGet(){
		$aUrl = parse_url($this->GetDest());
		$rConnect = @fsockopen($aUrl['host'], 80, $errno, $errstr, 30);
		if($rConnect){
			$sSend = "GET " . $aUrl['path'] . @$aUrl['query'] . "  HTTP/1.1\r\n";
			$sSend .= "Host: " . $aUrl['host'] . "\r\n";
			$sSend .= "Connection: Close\r\n\r\n";
			fwrite($rConnect,$sSend);
		   	$sData = "";
		   	while(!feof($rConnect)){
				$sData .= @fgets($rConnect,128);
			}
			fclose($rConnect);
			$aRSS = @explode("\\r\\", $sData);
			if(isset($aRSS[1]))
				return($aRSS[1]);
			return(false);
		}
	}
	// get via fopen
	function FopenGet(){
		$rConnect = @fopen($this->GetDest(),"r");
		if($rConnect){
			$sData = "";
			while(!feof($rConnect)){
				$sData .= fread($rConnect,4096);
			}
			fclose($rConnect);
			return($sData);
		}
		return(false);
	}
	// get via curl
	function CurlGet(){
		if(!extension_loaded('curl')){
			if(!dl('curl.so')){
				return(false);
			}
		}
		$rCurl = curl_init();
		curl_setopt($rCurl,CURLOPT_URL, $this->GetDest());
		curl_setopt($rCurl,CURLOPT_RETURNTRANSFER, true);
		$sOutput = curl_exec($rCurl);
		curl_close($rCurl);
		return($sOutput);
	}
	// determine method to get url
	function GetFile(){
		$aMethods = array("SocketGet","FopenGet","CurlGet");
		if(!isset($aMethods[$this->GetType()])){
			// try all methods
			for($x=0;$x<count($aMethods);$x++){
				if(false!==($sData = $this->$aMethods[$x]())){
					return($sData);
				}
			}
			return(false);
		}
		else{
			// try one single method to get file
			if(false!==($sData = $aMethods[$this->GetType()]())){
				return($sData);
			}
			return(false);
		}
	}
}
?>