<?php
/*
Function to decide whether to output something or not
	
Variable output is based upon the configuration variables in $_CONTEXT, 
$_CONTEXT['verbose']: verbose output, will always output anything
$_CONTEXT['silent']: verbose output, will always output anything
	
If $_CONTEXT['silent'] is empty nothing will ever be sent to the output, in any other case there will always be output, with an 
exception when both verbose and silent are false and $iOut is equal to zero.
This behaviour can allow you to have total control over your output.

PARAMETERS:
$sString: string to output
$bVerbose: verbose output
$bSilent: no output
$iOut: send or stop output when both verbose and silent are turned off, default is on (OPTIONAL)

RETURNS:
STRING: either empty or the output
*/
function Screen($sString,$bVerbose,$bSilent,$iOut=1){
	if($bSilent || (!$bVerbose && $iOut=0 && !$bSilent)){
		$sString = "";
	}
	return($sString);
}
?>