<?php
/* Validate environments paths */
if(!defined('IN_SCRIPT')){
	exit;
}
(!IsThere($_PATHS['functions_root']."/getfilebydir.php") ? include($_PATHS['end']) : include_once($_PATHS['functions_root']."/getfilebydir.php"));
(!IsThere($_PATHS['functions_root']."/getdirbydir.php") ? include($_PATHS['end']) : include_once($_PATHS['functions_root']."/getdirbydir.php"));
$sCode = "			<div class=\"configtablewrap\">\n";
$sCode .= "				<div class=\"configtable\">\n";
$sCode .= "					<div class=\"configtablerowalt\">\n";
$sCode .= "						<div class=\"configtabledesc\">Validate paths in the hacksuite</div>\n";
$sCode .= "					</div>\n";
$sCode .= "					<div class=\"clear\"></div>\n";
foreach($_PATHS as $sName=>$sValue){
	$sCode .= "					<div class=\"configtablerowalt\">\n";
	$sCode .= "						<div class=\"configtableleft200\">".$sName."</div><div class=\"configtableright300\">";
	// windows and linux compatiblity
	if(is_file($sValue)){
		// it's a file but does it exist?
		$sCode .= (!file_exists($sValue) ? "<font style=\"color:#ff0000\">".$sValue : "<font style=\"color:#6a5acd\">".$sValue)."</font>";
	}
	elseif(is_dir($sValue)){
		// it's a directory, let's get the content
		if(!$aDirs = GetDirByDir($sValue)){
			$aDirs = array();
		}
		if(!$aRootFiles = GetFilesByDirectory($sValue)){
			$aRootFiles = array();
		}
		/* map directory */
		$sCode .= "			<div><b>files:</b> ".count($aRootFiles)." <b>sub-folders:</b>".count($aDirs)."</div>";
	}
	else{
		$aUrl = @parse_url($sValue);
		$sCode .= (isset($aUrl['host']) ? $sValue : " [path identifier: ".$sValue."]");
	}
	$sCode .= "				</div>\n";
	$sCode .= "			</div>\n";
	$sCode .= "			<div class=\"clear\"></div>\n";
}
$sCode .= "				</div>\n";
$sCode .= "			</div>\n";
?>