if (typeof(loadFirebugConsole) != 'undefined') { loadFirebugConsole(); }
if (typeof(console) == 'undefined') { console = {debug: function() {}}; }

$(document).ready(function() {
$('ul#faqList').simpleFAQ({
  showOnlyOne: true,
  allowSearch: true,
  searchNode: '#faqSearch',
  minSearchScore: 0.5,
  sortSearch: true
});

$('ul#faqList').bind('searchStart.simpleFAQ', function(jQEvent) {
  console.debug("Search started...");
});
$('ul#faqList').bind('sort.simpleFAQ', function(jQEvent, results) {
  console.debug(results);
});
$('ul#faqList').bind('searchEnd.simpleFAQ', function(jQEvent, results) {
  console.debug(results);
  console.debug("...complete.");
});
});