<?php
/* Recovers default values for configuration files */
if(!defined('IN_SCRIPT')){
	exit;
}
if(isset($_POST['sConfigFile'])){
	// form submitted..
	$sDest = $_PATHS['properties_root']."/".trim($_POST['sConfigFile']);
	(!IsThere($sDest) ? include($_PATHS['end']) : include_once($sDest));
	// get the properties file
	$sData = "";
	foreach($_PROPERTIES as $sVar=>$aValues){
		$sData .= $sVar."|".str_replace("|","&#166;",str_replace("\n"," ",$aValues['default_value']))."\n";
	}
	if($sData==""){
		$_CONTEXT['errors'][] = "Unexpected or no data in properties file";
		include($PATHS['end']);
	}
	else{
		$sDest = $_PATHS['functions_root']."/fwrite.php";
		(!IsThere($sDest) ? include($_PATHS['end']) : include($sDest));
		// update the file's content or create a new file if it's not present
		if(!WriteF($_PATHS['config_root']."/".$_POST['sConfigFile'],$sData,"w")){
			include($_PATHS['end']);
		}
		$sCode .= "<font class=\"spacing\">Update succeeded, click <a href=\"javascript:history.back();\">here</a> to go back</font>\n";
	}
}
else{
	/* ok let's get all files in the Properties directory */
	$sDest = $_PATHS['functions_root']."/getfilebydir.php";
	(!IsThere($sDest) ? include($_PATHS['end']) : include($sDest));
	$sSelect = "";
	if(false!==($aFiles = GetFilesByDirectory($_PATHS['config_root']))){
		for($x=0;$x<count($aFiles);$x++){
			// buffer the files we need
			$sSelect .= "<option value=\"".$aFiles[$x]."\"".($sSelect!="" ? "" : " selected").">".$aFiles[$x]."</option>\n";
		}
		// setup configuration file selection form
		$sSelect = "<select name=\"sConfigFile\">\n".$sSelect."</select>\n";
		$sCode .= "<form method=\"post\">\n";
		$sCode .= "	<div class=\"configtablewrap\">\n";
		$sCode .= "		<div class=\"configtable\">\n";
		$sCode .= "			<div class=\"configtablerow\">\n";
		$sCode .= "				<div class=\"configtabledesc\">Return to the default values for a configuration file.</div>\n";
		$sCode .= "			</div>\n";
		$sCode .= "			<div class=\"clear\"></div>\n";
		$sCode .= "			<div class=\"configtablerow\">\n";
		$sCode .= "				<div class=\"configtableleft\">select a file:</div><div class=\"configtableright\">".$sSelect."</div>\n";
		$sCode .= "			</div>\n";
		$sCode .= "			<div class=\"clear\"></div>\n";
		$sCode .= "			<div class=\"configtablerow\">\n";
		$sCode .= "				<div class=\"configtablesubmit\"><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\"><input type=\"submit\" name=\"submit\" value=\"Recover File\"></div>\n";
		$sCode .= "			</div>\n";
		$sCode .= "		</div>\n";
		$sCode .= "	</div>\n";
		$sCode .= "</form>\n";
	}
	else{
		$sCode .= "<font class=\"spacing\">No files in the properties directory</font>\n";
	}
}
?>