<?php
/* Manager for widgets */
if(!defined('IN_SCRIPT')){
	exit;
}
// target files we need, so make sure they are present
$aFiles = array($_PATHS['functions_root']."/fwrite.php",$_PATHS['data_root']."/widgets.php",$_PATHS['functions_root']."/get_file_data.php");
for($x=0;$x<count($aFiles);$x++){
	(!IsThere($aFiles[$x]) ? include($_PATHS['end']) : include($aFiles[$x]));
}
if(!isset($_CONTEXT['widgets'])){
	$_CONTEXT['errors'][] = "No widgets present";
	include($_PATHS['end']);
}
// simple verification of content and extractor of useful stuff in the big widget array
$_CONTEXT['widget'] = array();
$_CONTEXT['widget']['keys'] = array();
$_CONTEXT['widget']['active'] = array();
foreach($_CONTEXT['widgets'] as $sKey=>$aValues){
	$_CONTEXT['widget']['keys'][] = $sKey;
	$_CONTEXT['widget']['active'][] = $aValues['active'];
}
if(false==($iItems = count($_CONTEXT['widget']['keys']))){
	// no widgets or maybe a corrupt file or array
	$_CONTEXT['errors'][] = "No widgets present or are you sure the file contains the proper data?";
	// no need to end just log a warning if necessary
}
if(isset($_POST['submit'])){
	switch($_POST['submit']){
		// activate or deactivate
		case"Change State":
		if(false==($sData = GetFileData($_PATHS['data_root']."/widgets.php"))){
			include($_PATHS['end']);
		}
		$sBeforeH = md5($sData);
		// verify submitted form field
		for($x=0;$x<count($_CONTEXT['widget']['keys']);$x++){
			$sVar = strtolower($_CONTEXT['widget']['keys'][$x]);
			if(!isset($_POST[$sVar])){
				$_CONTEXT['errors'][] = "Expecting variable <b>".$sVar."</b> to be present for widget <b>".$_CONTEXT['widget']['keys'][$x]."</b>";
				include($_PATHS['end']);
			}
			$iNew = $_POST[$sVar]!=1 ? 0 : 1;
			$iCurrent = $_CONTEXT['widget']['active'][$x]!=1 ? 0 : 1;
			$sData = str_replace("\$_CONTEXT['widgets']['".$sVar."']['active'] = ".$iCurrent.";","\$_CONTEXT['widgets']['".$sVar."']['active'] = ".$iNew.";",$sData);
		}
		$sAfterH = md5($sData);
		if($sAfterH==$sBeforeH){
			$sCode .= "<font class=\"spacing\">No changes have been made.. click <a href=\"javascript:history.go(-1)\">here</a> to return</font>\n";
		}
		else{
			if(!WriteF($_PATHS['data_root']."/widgets.php",$sData,"w")){
				include($_PATHS['end']);
			}
			else{
				$sCode .= "<font class=\"spacing\">Update succeeded, click <a href=\"javascript:history.go(-1)\">here</a> to return</font>\n";
			}
		}
		break;
		// default
		default:
		$_CONTEXT['errors'][] = "Invalid submission button value";
		include($_PATHS['end']);
	}
}
else{
	// output form
	$sCode .= "			<form method=\"post\">\n";
	$sCode .= "				<div class=\"widgetsx\">\n";
	for($x=0;$x<count($_CONTEXT['widget']['keys']);$x++){
		$sCode .= "					<div class=\"widget\">\n";
		$iCurrent = $_CONTEXT['widget']['active'][$x]!=1 ? 0 : 1;
		$sVar = strtolower($_CONTEXT['widget']['keys'][$x]);
		$sCode .= "						<div class=\"wlabel\">".$_CONTEXT['widget']['keys'][$x]."</div>\n";
		$sCode .= "						<div class=\"wfield\"><b>active</b> <input type=\"radio\" name=\"".$sVar."\" value=\"1\" ".($iCurrent==1 ? "checked" : "")." /> <b>disabled</b> <input type=\"radio\" name=\"".$sVar."\" value=\"0\" ".($iCurrent==0 ? "checked" : "")." /></div>\n";
		$sCode .= "					</div>\n";
		$sCode .= "					<div class=\"clear\"></div>\n";
	}
	$sCode .= "					<div class=\"wsubmit\"><input type=\"submit\" name=\"submit\" value=\"Change State\" /><input type=\"hidden\" name=\"iCFG\" value=\"".$_POST['iCFG']."\"></div>\n";
	$sCode .= "				</div>\n";
	$sCode .= "			</form>\n";
}
?>